# CACHE SETUP
proxy_cache_path
  /var/cache/nginx
  levels=1:2
  keys_zone=my_cache_{{ nginx_policies['env_name'] | hash('md5') }}:10m
  max_size=10g
  inactive=10s
  use_temp_path=off;

###############################################################################
### UPSTREAMS DECLARATION
###############################################################################
{% include "nginx-http-upstreams.j2" %}

###############################################################################
### ENV MODSEC CONFIG
###############################################################################
{% if modsec_enabled %}
  {% include "nginx-http-modsec.j2" %}
{% endif %}

###############################################################################
### SERVERS
###############################################################################

server {
  listen 443 ssl http2 default_server; # IPv4
  ssl_certificate     /etc/nginx/certs/{{ cert_name }}.pem;
  ssl_certificate_key /etc/nginx/certs/{{ cert_name }}.key;
  server_name _;
  server_name "";

  location / {
    return 404;
  }

  location ~* ^/nginx_status$ {
    #METRICS
    stub_status;
    access_log off;
    allow      127.0.0.1;
    deny       all;
  }

  location ~* ^/snet$ {
    # HEALTH CHECK
    error_log    off;
    access_log   off;
{% if modsec_enabled %}
    modsecurity  off;
{% endif %}
    return 200;
    break;
  }
}

{% for service in nginx_policies['services'] %}
  {% set port = service["port"] | string %}
    server {{'{'}}
      # server_tokens off; # now in global
      server_name {{ service['hostname'] }};

      {% if port == "443" %}
        listen {{ port }} ssl http2;
        ssl_certificate     /etc/nginx/certs/{{ cert_name }}.pem;
        ssl_certificate_key /etc/nginx/certs/{{ cert_name }}.key;
        ssl_session_timeout 15m;
        ssl_session_cache shared:SSL:15m;
        ssl_protocols TLSv1.2 TLSv1.3;
        ssl_ciphers "ECDHE-RSA-AES128-GCM-SHA256:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-RSA-AES256-GCM-SHA384";
        ssl_prefer_server_ciphers on;
      {% else %}
        listen {{ port }}
      {% endif %}

      {% if "logging" in nginx_policies and nginx_policies['logging'] is not none %}
        #log_format main '$remote_addr $host $http_authuser [$time_local] "$request" $status $body_bytes_sent "$http_referer" "$http_user_agent" $ssl_cipher $request_time $http_x_forwarded_for';
        {% for log in nginx_policies['logging'] %}
          {{ log }};
        {% endfor %}
      {% endif %}

      proxy_cache_bypass $http_pragma $http_cache_control;
      proxy_cache my_cache_{{ nginx_policies['env_name'] | hash('md5')}};
      proxy_cache_revalidate on;

      proxy_http_version 1.1;
      gzip on;

      keepalive_timeout  10000;
      keepalive_requests  50;
      set $default_sorry "https://sorry.ec.europa.eu";

      ###############################################################################
      ### PROBING GENERATION #
      ###############################################################################
      {% include "nginx-http_server-probing.j2" %}

      ###############################################################################
      ### MAPPING GENERATION #
      ###############################################################################
      {% include "nginx-http_server-mappings.j2" %}
    {{'}'}}
{% endfor %}
